﻿package  {
	
	import dong.prize.Mushroom;
	import dong.prize.Star;
	import dong.UserEvent;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.ui.Keyboard;
	import com.motion.Collision;
	import dong.pc.Mario;
	import dong.EnemySpr;
	import dong.PrizeSpr;
	import dong.Parameter;
	import dong.hint.Discription;
	import com.greensock.TweenLite;
	
	public class Main extends MovieClip {
		
		private var mario:Mario;
		private var enemySpr:EnemySpr;
		private var prizeSpr:PrizeSpr;
		private var discription:Discription=new Discription();
		
		private var gameOverBut:GameOver;
		public var __points:MovieClip;
		public var __score:MovieClip;
		
		private var _N:int = 1;//用于计数
		private var _score:int = 0;
		private var _rewardScoreArr:Array = [10,15,20];//每关过关后奖励的分数
		public function Main() {
			// constructor code
			stage?initGame():addEventListener(Event.ADDED_TO_STAGE, initGame);
		}
		/**
		 * 加载过程
		 * @param	e
		 */
		private function initGame(e:Event=null) {
			removeEventListener(Event.ADDED_TO_STAGE, initGame);
			addEventListener(Event.ENTER_FRAME, loadingFun);
			}
		private function loadingFun(e:Event) {
			var num:Number = root.loaderInfo.bytesLoaded / root.loaderInfo.bytesTotal; trace(num);
			txt.text = "已加载" + Math.floor(num * 1000) / 10 + "%";
			if (num >= 1) {
				removeEventListener(Event.ENTER_FRAME, loadingFun);
				this.gotoAndStop(2);
				startGame();
				}
			}
		/**
		 * 游戏部分
		 */
		private function startGame() {
			//初始化分数
			_score = 0;
			__score.__txt.text = String(_score);
			//初始化关卡
			__points.gotoAndStop(Parameter.points);
			//初始化敌人
			enemySpr = new EnemySpr();
			addChild(enemySpr);
			//初始化奖品
			prizeSpr = new PrizeSpr();
			addChild(prizeSpr);
			//初始化玛丽
			mario = new Mario(100, 300, stage);
			addChild(mario);
			//初始化游戏说明
			//discription = new Discription();
			addChild(discription);
			discription.flyIn();
			//侦听事件
			this.addEventListener(Event.ENTER_FRAME, stateJudge);
			this.addEventListener(UserEvent.DISCRIPTION_OVER, discriptionOverFun);
			}
		/**
		 * 判断游戏当前状态
		 */
		private function stateJudge(e:Event) {
			if (!Parameter.gameTime) {
				mario.x = 55; mario.y = 100; mario.scaleX = 1;
				_N=(_N+1)%6;
				if (_N == 0) {
					mario.visible?mario.visible=false:mario.visible=true;
					}
				}
			else {
				collisionTest();//非过关状态才检测碰撞
				}
			}
		/**
		 * 游戏说明牌消失之后的操作
		 * @param	e
		 */
		private function discriptionOverFun(e:UserEvent) {
			trace(Parameter.discriptionCurFrame);
			if (Parameter.points==0) {
				Parameter.points++;
				startGame();
				}
			if (!Parameter.gameTime) {
				mario.clearanceMode = true;
				discription.flyIn();
				}
			else {
				mario.clearanceMode = false; 
				mario.visible = true;
				mario.godMode = true;
				stage.focus = stage;
				}
			}
		/**
		 * 游戏过程中要不断地检测碰撞
		 * @param	e
		 */
		private function collisionTest() {
			for (var i = 0; i < enemySpr.numChildren; i++ ) {
				var enemyMc:MovieClip = enemySpr.getChildAt(i) as MovieClip;
				if (Collision.collisionTest(mario, enemyMc)) {
					if (mario.godMode) {
						enemyMc.visible = false;
						enemyMc.die();
						}
					else {
						mario.isAlive = false;
						TweenLite.to(mario, 1, { x:mario.x, y:-30,onComplete:gameOverFun} );
						}
					}
				}
			for (var j = 0; j < prizeSpr.numChildren; j++ ) {
				var prizeMc:MovieClip = prizeSpr.getChildAt(j) as MovieClip;
				if (Collision.collisionTest(mario, prizeMc)) {
					prizeMc.visible = false; 
					prizeMc.die();
					if (prizeMc is Mushroom) {
						upsetScore(prizeMc.score);
						if (clearance()) {
							upsetScore(_rewardScoreArr[Parameter.points-1]);
							Parameter.points ++;
							nextLevel();
							}
						}
					if (prizeMc is Star) {
						mario.godMode = true;
						}
					}
				}
			}
		/**
		 * 判断是否满足过关条件，满足返回true，不满足返回false
		 **/
		private function clearance():Boolean {
			var win:Boolean = false;
			switch(Parameter.points) {
				case 1: {
					_score == 10?win = true:win = false;
					break;
					}
				case 2: {
					_score == 35?win = true:win = false;
					break;
					}
				case 3: {
					break;
					}
				}
			return win;
			}
		/**/
		private function nextLevel() {
			__points.gotoAndStop(Parameter.points);
			
			discription.flyIn();
			}
		/**
		 * 游戏失败
		 */
		private function gameOverFun() {
			removeChild(enemySpr);
			removeChild(prizeSpr);
			removeChild(mario);
			Parameter.points = 0;
			Parameter.discriptionCurFrame = 1;
			discription.flyIn();
			}
		private function upsetScore(plus:int) {
			_score += plus;
			__score.__txt.text = String(_score);
			}
	}
	
}
