﻿package dong.enemy {
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.geom.ColorTransform;
	import com.math.PrimaryMath;
	
	public class Ball extends MovieClip {
		
		private var _vx:Number;
		private var _vy:Number;
		private var _g:Number = 1.0;
		private const GROUND_Y:int = 300;
		private var colorArr:Array = [[0, 0, 0],
										[0, 0, 1],
										[0, 1, 1],
										[0, 1, 0],
										[1, 1, 0],
										[1, 0, 0],
										[1, 0, 1]];
										
		private var _moveMode:int = 1;
		public static const RIGHT2LEFT:int = 1;
		public static const LEFT2RIGHT:int = -1;
		
		private var _ballMode:String = "normal";
		public static const NORMAL:String = "normal";
		public static const BIG:String = "big";
		
		private var _jumpMode:String = "haveLoss";
		public static const HAVELOSS:String = "haveLoss";
		public static const NOLOSS:String = "noLoss";
		
		public function Ball() {
			// constructor code
			this._vx = -Math.random() * 3 -3;
			this._vy = 0;
			this.x = 580;
			this.y = Math.random() * 60 + 180;
			this.addEventListener(Event.ENTER_FRAME, move);
			var a:int = Math.round(Math.random() * 6);
			this.transform.colorTransform = new ColorTransform(colorArr[a][0],colorArr[a][1],colorArr[a][2],1);
		}
		private function move(e:Event) {
			rolling();
			this.x += _vx;
			switch(_jumpMode) {
				case "haveLoss": {
					_vy += _g;
					this.y += _vy;
					break;
					}
				case "noLoss": {
					this.y += _vy;
					_vy += _g;
					break;
					}
				}
			if (this.y>= GROUND_Y-this.width/2) {
				this.y = GROUND_Y-this.width/2;
				_vy *= -1;
				}
			if (this.x < -this.width-10||this.x>580+this.width) {
				die();
				}
			}
		public function die() {
			this.removeEventListener(Event.ENTER_FRAME, move);
			if (parent) parent.removeChild(this); 
			}
		private function rolling() {
			this.rotation += PrimaryMath.redian2angle(_vx*2/this.width);
			}
		/**/
		public function set jumpMode(mode:String) {
			_jumpMode = mode;
			}
		/**
		 * 设置球的运动方向
		 */
		public function set moveMode(dir:int) {
			switch(dir) {
				case LEFT2RIGHT: {
					_moveMode = -1;
					this.x = -this.width;
					_vx = -_vx;
					break;
					}
				default: {
					break;
					}
				}
			}
		/**
		 * 设置球的模式，不同模式对应不同外形（如大小）
		 */
		public function set ballMode(mode:String) {
			switch(mode) {
				case "big": {
					_ballMode="big"
					this.scaleX = 3;
					this.scaleY = 3;
					this.y = GROUND_Y-this.height/2;
					//this._g = 0;
					break;
					}
				default:{
					break;
					}
				}
			}
	}
	
}
