﻿package dong.pc {
	
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import com.motion.VisualDy;
	
	/*
	 * author:韩利冬
	 * date:2013.05.24
	 */
	public class Mario extends MovieClip {
		
		private var vx:Number = 0;
		private var vy:Number = 0;
		private var maxV:Number =6;
		private var g:Number = 1.0;
		private var jumpForce:Number = 20.0;
		private var ux:Number = 0.05;
		private var uy:Number = 0.05;
		private var groundY:int = 400;
		private var stageMario:Stage;
		private var key:Object = new Object();
		private var alive:Boolean = true;
		private var isDie:Boolean = false;
		
		/**
		 *　无敌模式，此状态下，玛丽可以得分，消灭一切碰撞到的敌人。
		 */
		private var _godMode:Boolean = false;
		/**
		 *　子弹模式，此状态下，玛丽可以发射子弹。
		 */
		private var _bulletMode:Boolean = false;
		/**
		 *　过关模式，此状态下，不得分也不会死亡。
		 */
		public var clearanceMode:Boolean = false;
		
		public function Mario(positionX:int,positionY:int,sta:Stage) {
			// constructor code
			this.gotoAndStop(1);
			this.x = positionX;
			this.y = positionY;
			groundY = positionY;
			stageMario=sta;
			stageMario.addEventListener(KeyboardEvent.KEY_DOWN, keyDown);
			stageMario.addEventListener(KeyboardEvent.KEY_UP, keyUp);
			stageMario.addEventListener(Event.ENTER_FRAME, startMove);
		}
		private function keyDown(e:KeyboardEvent) {
			key[e.keyCode] = true;
			}
		private function keyUp(e:KeyboardEvent) {
			key[e.keyCode] = false;
			}
		private function startMove(e:Event) {
			alive?move():die();
			}
		private function move() {
				checkKey();
				//更新速度
				if (Math.abs(vx) < 1) {
					vx = 0;
					}
					else {
						vx -= vx * ux;
						}
					
				if (this.y + vy + g - vy * uy > groundY) { 
					this.y = groundY;
					vy = 0;
					}
					else{
					vy += (g-vy*uy);
					}
				//更新位置
				if (this.x+vx>0&&this.x+vx<550) {
					this.x += vx ;
					}
				this.y += vy ;
				//人物的动画效果。
				if (this.y < groundY) {
					this.gotoAndStop(3);
					}
					else if (vx != 0) {
						if (vx<0) {
							this.scaleX = -1;
							}else
							{this.scaleX = 1;}
						this.play();
						}
						else {
							if (this.currentFrame == 3)
							{this.gotoAndStop(1);}
							}
				}
		private function checkKey() {
			for (var i in key) {
				if (i==Keyboard.RIGHT&&key[i]==true) {
					if (vx < maxV) { vx++; }
					}
				if (i==Keyboard.LEFT&&key[i]==true) {
					if (vx > - maxV) { vx--; }
					}
				if (i==Keyboard.UP&&key[i]==true) {
					if (this.y == groundY) { vy = -jumpForce; }
					}
				}
			}
		private function die() {
			if (!isDie) {
				this.gotoAndStop(5);
				isDie = true;
				}
			}
		/*设置地面的y坐标*/
		public function set GroundY(a:int) {
			groundY = a;
			}
		/**
		 * 玛丽是否还活着
		 */
		public function set isAlive(a:Boolean) {
			alive = a;
			}
		public function get godMode():Boolean {
			return _godMode;
			}
		public function set godMode(mode:Boolean) {
			_godMode = mode;
			if (mode) {
				VisualDy.starShow(this, 3, 0.5, 50, function() {
					_godMode = false;
					});
				}
			}
	}
	
}
